diff -ur asterisk-1.2.9/channels/chan_iax2.c asterisk-1.2.9-work/channels/chan_iax2.c
--- asterisk-1.2.9/channels/chan_iax2.c	2006-06-06 03:53:16.000000000 +0800
+++ asterisk-1.2.9-work/channels/chan_iax2.c	2006-06-15 16:24:06.000000000 +0800
@@ -6787,6 +6787,15 @@
 							cur->retries = -1;
 					}
 					ast_mutex_unlock(&iaxq.lock);
+
+					/* Change transfer address to where this packet came from */
+					if (inaddrcmp(&sin, &iaxs[fr->callno]->transfer)) 
+						memcpy(&iaxs[fr->callno]->transfer, &sin, sizeof(iaxs[fr->callno]->transfer));
+
+					/* Send a TXACC back to transfer_host, in case we missed the original TXCNT */
+					/* This will break BACKWARDS compatibility */
+					send_command_transfer(iaxs[fr->callno], AST_FRAME_IAX, IAX_COMMAND_TXACC, 0, NULL, 0);
+
 					memset(&ied1, 0, sizeof(ied1));
 					iax_ie_append_short(&ied1, IAX_IE_CALLNO, iaxs[fr->callno]->callno);
 					send_command(iaxs[fr->callno], AST_FRAME_IAX, IAX_COMMAND_TXREADY, 0, ied1.buf, ied1.pos, -1);
@@ -7494,8 +7503,17 @@
 				try_transfer(iaxs[fr->callno], &ies);
 				break;
 			case IAX_COMMAND_TXCNT:
-				if (iaxs[fr->callno]->transferring)
-					send_command_transfer(iaxs[fr->callno], AST_FRAME_IAX, IAX_COMMAND_TXACC, 0, NULL, 0);
+				if (iaxs[fr->callno]->transferring) {
+					/* Reply to the source of the TXCNT */
+					struct chan_iax2_pvt *tmp;
+					tmp = malloc(sizeof(struct chan_iax2_pvt)); /* Hmm...got to free this somewhere */
+					if (tmp) {
+						memcpy(tmp, iaxs[fr->callno], sizeof(struct(chan_iax2_pvt)));
+						if (inaddrcmp(&sin, &iaxs[fr->callno]->transfer)) 
+							memcpy(&tmp->transfer, &sin, sizeof(tmp->transfer));
+						send_command_transfer(tmp, AST_FRAME_IAX, IAX_COMMAND_TXACC, 0, NULL, 0);
+					}
+				}
 				break;
 			case IAX_COMMAND_TXREL:
 				/* Send ack immediately, rather than waiting until we've changed addresses */
